#ifndef Time_First
#ifdef __GNUG__
//pragma once
#pragma interface
#endif
#define Time_First

#include "Types.h"
#include "Stream.h"

//---- Time --------------------------------------------------------------------

class Time {
public:
    Time();
    Time(long msec);                

    //----- operators                          
    Time operator+(Time &t);
    Time operator-(Time &t);
    Time operator*(int i);
    Time operator*(double f);
    
    //--- conversion
    long AsLong();
    long InMSec()
	{ return AsLong(); };
    char *AsString();
    
    //----- comparison  
    int Compare(Time &t);

    //---- syntactic sugar: relational operators
    bool operator==(Time &t)
	{ return Compare(t) == 0; };
    bool operator<(Time &t)
	{ return Compare(t) < 0; };
    bool operator<= (Time &t)
	{ return Compare(t) <= 0; };
    bool operator>(Time &t)
	{ return Compare(t) > 0; };
    bool operator>=(Time &t)
	{ return Compare(t) >= 0; };
    
    //---- Stream operators
    friend OStream &operator<< (OStream&, Time &t);
    friend IStream &operator>> (IStream&, Time &t);   
private:
    long val;
};

SimpleMetaDef(Time);

//------------------------------------------------------------------------------

#endif Time_First

